
module MenhirBasics = struct
  
  exception Error = Parsing.Parse_error
  
  let _eRR =
    fun _s ->
      raise Error
  
  type token = 
    | SYMB_REG of (
# 21 "lib/BPFParser.mly"
       (string)
# 15 "lib/BPFParser.ml"
  )
    | STAR
    | SIZE of (
# 25 "lib/BPFParser.mly"
       (BPFBase.signed * BPFBase.width)
# 21 "lib/BPFParser.ml"
  )
    | SEMI
    | RPAR
    | PROC of (
# 24 "lib/BPFParser.mly"
       (int)
# 28 "lib/BPFParser.ml"
  )
    | PLUS
    | PIPE
    | NUM of (
# 22 "lib/BPFParser.mly"
       (int)
# 35 "lib/BPFParser.ml"
  )
    | NAME of (
# 23 "lib/BPFParser.mly"
       (string)
# 40 "lib/BPFParser.ml"
  )
    | MINUS
    | LPAR
    | LOCK
    | IF
    | GOTO
    | EQUAL
    | EOF
    | COND of (
# 38 "lib/BPFParser.mly"
       (BPFBase.cond)
# 52 "lib/BPFParser.ml"
  )
    | COMMA
    | COLON
    | ARCH_REG of (
# 20 "lib/BPFParser.mly"
       (BPFBase.reg)
# 59 "lib/BPFParser.ml"
  )
    | AMOXCHGT of (
# 33 "lib/BPFParser.mly"
       (BPFBase.width)
# 64 "lib/BPFParser.ml"
  )
    | AMOF of (
# 32 "lib/BPFParser.mly"
       (BPFBase.op)
# 69 "lib/BPFParser.ml"
  )
    | AMOCMPXCHGT of (
# 34 "lib/BPFParser.mly"
       (BPFBase.width)
# 74 "lib/BPFParser.ml"
  )
    | ALU_OP of (
# 31 "lib/BPFParser.mly"
       (BPFBase.op)
# 79 "lib/BPFParser.ml"
  )
  
end

include MenhirBasics

# 1 "lib/BPFParser.mly"
  
(****************************************************************************)
(*                           the diy toolsuite                              *)
(*                                                                          *)
(* Copyright (c) 2024 Puranjay Mohan <puranjay@kernel.org>                  *)
(*                                                                          *)
(*                                                                          *)
(* This software is governed by the CeCILL-B license under French law and   *)
(* abiding by the rules of distribution of free software. You can use,      *)
(* modify and/ or redistribute the software under the terms of the CeCILL-B *)
(* license as circulated by CEA, CNRS and INRIA at the following URL        *)
(* "http://www.cecill.info". We also give a copy in LICENSE.txt.            *)
(****************************************************************************)

module A=BPFBase


# 104 "lib/BPFParser.ml"

type ('s, 'r) _menhir_state = 
  | MenhirState002 : ('s _menhir_cell0_semi_opt, _menhir_box_main) _menhir_state
    (** State 002.
        Stack shape : semi_opt.
        Start symbol: main. *)

  | MenhirState004 : (('s, _menhir_box_main) _menhir_cell1_PROC, _menhir_box_main) _menhir_state
    (** State 004.
        Stack shape : PROC.
        Start symbol: main. *)

  | MenhirState008 : (('s _menhir_cell0_semi_opt, _menhir_box_main) _menhir_cell1_proc_list, _menhir_box_main) _menhir_state
    (** State 008.
        Stack shape : semi_opt proc_list.
        Start symbol: main. *)

  | MenhirState015 : (('s, _menhir_box_main) _menhir_cell1_STAR _menhir_cell0_SIZE, _menhir_box_main) _menhir_state
    (** State 015.
        Stack shape : STAR SIZE.
        Start symbol: main. *)

  | MenhirState017 : ((('s, _menhir_box_main) _menhir_cell1_STAR _menhir_cell0_SIZE, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 017.
        Stack shape : STAR SIZE reg.
        Start symbol: main. *)

  | MenhirState025 : (((('s, _menhir_box_main) _menhir_cell1_STAR _menhir_cell0_SIZE, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_k, _menhir_box_main) _menhir_state
    (** State 025.
        Stack shape : STAR SIZE reg k.
        Start symbol: main. *)

  | MenhirState029 : (('s, _menhir_box_main) _menhir_cell1_NAME, _menhir_box_main) _menhir_state
    (** State 029.
        Stack shape : NAME.
        Start symbol: main. *)

  | MenhirState036 : (('s, _menhir_box_main) _menhir_cell1_LOCK _menhir_cell0_SIZE, _menhir_box_main) _menhir_state
    (** State 036.
        Stack shape : LOCK SIZE.
        Start symbol: main. *)

  | MenhirState037 : ((('s, _menhir_box_main) _menhir_cell1_LOCK _menhir_cell0_SIZE, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 037.
        Stack shape : LOCK SIZE reg.
        Start symbol: main. *)

  | MenhirState040 : (((('s, _menhir_box_main) _menhir_cell1_LOCK _menhir_cell0_SIZE, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_k _menhir_cell0_ALU_OP, _menhir_box_main) _menhir_state
    (** State 040.
        Stack shape : LOCK SIZE reg k ALU_OP.
        Start symbol: main. *)

  | MenhirState042 : (('s, _menhir_box_main) _menhir_cell1_IF, _menhir_box_main) _menhir_state
    (** State 042.
        Stack shape : IF.
        Start symbol: main. *)

  | MenhirState044 : ((('s, _menhir_box_main) _menhir_cell1_IF, _menhir_box_main) _menhir_cell1_reg _menhir_cell0_COND, _menhir_box_main) _menhir_state
    (** State 044.
        Stack shape : IF reg COND.
        Start symbol: main. *)

  | MenhirState054 : (('s, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 054.
        Stack shape : reg.
        Start symbol: main. *)

  | MenhirState060 : ((('s, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_STAR _menhir_cell0_SIZE, _menhir_box_main) _menhir_state
    (** State 060.
        Stack shape : reg STAR SIZE.
        Start symbol: main. *)

  | MenhirState061 : (((('s, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_STAR _menhir_cell0_SIZE, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 061.
        Stack shape : reg STAR SIZE reg.
        Start symbol: main. *)

  | MenhirState065 : ((('s, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_AMOXCHGT, _menhir_box_main) _menhir_state
    (** State 065.
        Stack shape : reg AMOXCHGT.
        Start symbol: main. *)

  | MenhirState066 : (((('s, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_AMOXCHGT, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 066.
        Stack shape : reg AMOXCHGT reg.
        Start symbol: main. *)

  | MenhirState068 : ((((('s, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_AMOXCHGT, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_k, _menhir_box_main) _menhir_state
    (** State 068.
        Stack shape : reg AMOXCHGT reg k.
        Start symbol: main. *)

  | MenhirState077 : ((('s, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_AMOF _menhir_cell0_SIZE, _menhir_box_main) _menhir_state
    (** State 077.
        Stack shape : reg AMOF SIZE.
        Start symbol: main. *)

  | MenhirState078 : (((('s, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_AMOF _menhir_cell0_SIZE, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 078.
        Stack shape : reg AMOF SIZE reg.
        Start symbol: main. *)

  | MenhirState081 : ((((('s, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_AMOF _menhir_cell0_SIZE, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_k, _menhir_box_main) _menhir_state
    (** State 081.
        Stack shape : reg AMOF SIZE reg k.
        Start symbol: main. *)

  | MenhirState085 : ((('s, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_AMOCMPXCHGT, _menhir_box_main) _menhir_state
    (** State 085.
        Stack shape : reg AMOCMPXCHGT.
        Start symbol: main. *)

  | MenhirState086 : (((('s, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_AMOCMPXCHGT, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 086.
        Stack shape : reg AMOCMPXCHGT reg.
        Start symbol: main. *)

  | MenhirState088 : ((((('s, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_AMOCMPXCHGT, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_k, _menhir_box_main) _menhir_state
    (** State 088.
        Stack shape : reg AMOCMPXCHGT reg k.
        Start symbol: main. *)

  | MenhirState090 : (((((('s, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_AMOCMPXCHGT, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_k, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_state
    (** State 090.
        Stack shape : reg AMOCMPXCHGT reg k reg.
        Start symbol: main. *)

  | MenhirState095 : (('s, _menhir_box_main) _menhir_cell1_reg _menhir_cell0_ALU_OP, _menhir_box_main) _menhir_state
    (** State 095.
        Stack shape : reg ALU_OP.
        Start symbol: main. *)

  | MenhirState103 : (('s, _menhir_box_main) _menhir_cell1_instr_option_list, _menhir_box_main) _menhir_state
    (** State 103.
        Stack shape : instr_option_list.
        Start symbol: main. *)

  | MenhirState106 : (('s, _menhir_box_main) _menhir_cell1_instr_option, _menhir_box_main) _menhir_state
    (** State 106.
        Stack shape : instr_option.
        Start symbol: main. *)


and ('s, 'r) _menhir_cell1_instr_option = 
  | MenhirCell1_instr_option of 's * ('s, 'r) _menhir_state * (BPFBase.pseudo)

and ('s, 'r) _menhir_cell1_instr_option_list = 
  | MenhirCell1_instr_option_list of 's * ('s, 'r) _menhir_state * (BPFBase.pseudo list)

and ('s, 'r) _menhir_cell1_k = 
  | MenhirCell1_k of 's * ('s, 'r) _menhir_state * (int)

and ('s, 'r) _menhir_cell1_proc_list = 
  | MenhirCell1_proc_list of 's * ('s, 'r) _menhir_state * (MiscParser.proc list)

and ('s, 'r) _menhir_cell1_reg = 
  | MenhirCell1_reg of 's * ('s, 'r) _menhir_state * (A.reg_arg)

and 's _menhir_cell0_semi_opt = 
  | MenhirCell0_semi_opt of 's * (unit)

and 's _menhir_cell0_ALU_OP = 
  | MenhirCell0_ALU_OP of 's * (
# 31 "lib/BPFParser.mly"
       (BPFBase.op)
# 270 "lib/BPFParser.ml"
)

and ('s, 'r) _menhir_cell1_AMOCMPXCHGT = 
  | MenhirCell1_AMOCMPXCHGT of 's * ('s, 'r) _menhir_state * (
# 34 "lib/BPFParser.mly"
       (BPFBase.width)
# 277 "lib/BPFParser.ml"
)

and ('s, 'r) _menhir_cell1_AMOF = 
  | MenhirCell1_AMOF of 's * ('s, 'r) _menhir_state * (
# 32 "lib/BPFParser.mly"
       (BPFBase.op)
# 284 "lib/BPFParser.ml"
)

and ('s, 'r) _menhir_cell1_AMOXCHGT = 
  | MenhirCell1_AMOXCHGT of 's * ('s, 'r) _menhir_state * (
# 33 "lib/BPFParser.mly"
       (BPFBase.width)
# 291 "lib/BPFParser.ml"
)

and 's _menhir_cell0_COND = 
  | MenhirCell0_COND of 's * (
# 38 "lib/BPFParser.mly"
       (BPFBase.cond)
# 298 "lib/BPFParser.ml"
)

and ('s, 'r) _menhir_cell1_IF = 
  | MenhirCell1_IF of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_LOCK = 
  | MenhirCell1_LOCK of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_NAME = 
  | MenhirCell1_NAME of 's * ('s, 'r) _menhir_state * (
# 23 "lib/BPFParser.mly"
       (string)
# 311 "lib/BPFParser.ml"
)

and ('s, 'r) _menhir_cell1_PROC = 
  | MenhirCell1_PROC of 's * ('s, 'r) _menhir_state * (
# 24 "lib/BPFParser.mly"
       (int)
# 318 "lib/BPFParser.ml"
)

and 's _menhir_cell0_SIZE = 
  | MenhirCell0_SIZE of 's * (
# 25 "lib/BPFParser.mly"
       (BPFBase.signed * BPFBase.width)
# 325 "lib/BPFParser.ml"
)

and ('s, 'r) _menhir_cell1_STAR = 
  | MenhirCell1_STAR of 's * ('s, 'r) _menhir_state

and _menhir_box_main = 
  | MenhirBox_main of (MiscParser.proc list * BPFBase.pseudo list list) [@@unboxed]

let _menhir_action_01 =
  fun _1 _2 _3 ->
    (
# 86 "lib/BPFParser.mly"
  ( A.OP (_2,_1,_3) )
# 339 "lib/BPFParser.ml"
     : (A.pins))

let _menhir_action_02 =
  fun _1 _2 _3 ->
    (
# 89 "lib/BPFParser.mly"
  ( A.OPI (_2,_1,_3) )
# 347 "lib/BPFParser.ml"
     : (A.pins))

let _menhir_action_03 =
  fun _1 _10 _5 _9 ->
    (
# 93 "lib/BPFParser.mly"
  ( let s,w = _5 in
    A.LOAD (w,s,_1,_9,_10) )
# 356 "lib/BPFParser.ml"
     : (A.pins))

let _menhir_action_04 =
  fun _11 _3 _7 _8 ->
    (
# 98 "lib/BPFParser.mly"
  ( let _,w = _3 in
    A.STORE (w,_7,_8,_11) )
# 365 "lib/BPFParser.ml"
     : (A.pins))

let _menhir_action_05 =
  fun _11 _3 _7 _8 ->
    (
# 103 "lib/BPFParser.mly"
  ( let _,w = _3 in
    A.STOREI (w,_7,_8,_11) )
# 374 "lib/BPFParser.ml"
     : (A.pins))

let _menhir_action_06 =
  fun _1 _3 ->
    (
# 108 "lib/BPFParser.mly"
  ( A.MOV(_1, _3))
# 382 "lib/BPFParser.ml"
     : (A.pins))

let _menhir_action_07 =
  fun _1 _3 ->
    (
# 112 "lib/BPFParser.mly"
  ( A.MOVI(_1, _3))
# 390 "lib/BPFParser.ml"
     : (A.pins))

let _menhir_action_08 =
  fun _10 _11 _14 _3 _6 ->
    (
# 116 "lib/BPFParser.mly"
  ( let op = _3 in
    let _,w = _6 in
   A.AMO(op, w, _10, _11, _14, A.SC, true) )
# 400 "lib/BPFParser.ml"
     : (A.pins))

let _menhir_action_09 =
  fun _3 _5 _6 _8 ->
    (
# 122 "lib/BPFParser.mly"
  ( let sz = _3 in
   A.AMO(A.AMOXCHG, sz, _5, _6, _8, A.SC, true) )
# 409 "lib/BPFParser.ml"
     : (A.pins))

let _menhir_action_10 =
  fun _10 _3 _5 _6 ->
    (
# 127 "lib/BPFParser.mly"
  ( let sz = _3 in
   A.AMO(A.AMOCMPXCHG, sz, _5, _6, _10, A.SC, true) )
# 418 "lib/BPFParser.ml"
     : (A.pins))

let _menhir_action_11 =
  fun _11 _12 _4 _8 _9 ->
    (
# 132 "lib/BPFParser.mly"
  ( let _,w = _4 in
      let op = _11 in
    A.AMO(op, w, _8, _9, _12, A.X, false) )
# 428 "lib/BPFParser.ml"
     : (A.pins))

let _menhir_action_12 =
  fun _2 ->
    (
# 138 "lib/BPFParser.mly"
  ( A.GOTO(_2) )
# 436 "lib/BPFParser.ml"
     : (A.pins))

let _menhir_action_13 =
  fun _2 _3 _4 _6 ->
    (
# 142 "lib/BPFParser.mly"
  ( let c=_3 in
    A.JCOND(c, _2, _4, _6)  )
# 445 "lib/BPFParser.ml"
     : (A.pins))

let _menhir_action_14 =
  fun _2 _3 _4 _6 ->
    (
# 145 "lib/BPFParser.mly"
  ( let c=_3 in
    A.JCONDI(c, _2, _4, _6)  )
# 454 "lib/BPFParser.ml"
     : (A.pins))

let _menhir_action_15 =
  fun () ->
    (
# 68 "lib/BPFParser.mly"
             ( A.Nop )
# 462 "lib/BPFParser.ml"
     : (BPFBase.pseudo))

let _menhir_action_16 =
  fun _1 _3 ->
    (
# 69 "lib/BPFParser.mly"
                          ( A.Label (_1,_3) )
# 470 "lib/BPFParser.ml"
     : (BPFBase.pseudo))

let _menhir_action_17 =
  fun _1 ->
    (
# 70 "lib/BPFParser.mly"
             ( A.Instruction _1)
# 478 "lib/BPFParser.ml"
     : (BPFBase.pseudo))

let _menhir_action_18 =
  fun _1 ->
    (
# 63 "lib/BPFParser.mly"
      ([_1])
# 486 "lib/BPFParser.ml"
     : (BPFBase.pseudo list))

let _menhir_action_19 =
  fun _1 _3 ->
    (
# 65 "lib/BPFParser.mly"
      (_1::_3)
# 494 "lib/BPFParser.ml"
     : (BPFBase.pseudo list))

let _menhir_action_20 =
  fun _1 ->
    (
# 58 "lib/BPFParser.mly"
    ([_1])
# 502 "lib/BPFParser.ml"
     : (BPFBase.pseudo list list))

let _menhir_action_21 =
  fun _1 _3 ->
    (
# 59 "lib/BPFParser.mly"
                                   (_1::_3)
# 510 "lib/BPFParser.ml"
     : (BPFBase.pseudo list list))

let _menhir_action_22 =
  fun _1 ->
    (
# 77 "lib/BPFParser.mly"
      ( _1 )
# 518 "lib/BPFParser.ml"
     : (int))

let _menhir_action_23 =
  fun _2 ->
    (
# 78 "lib/BPFParser.mly"
            ( -_2 )
# 526 "lib/BPFParser.ml"
     : (int))

let _menhir_action_24 =
  fun _2 ->
    (
# 79 "lib/BPFParser.mly"
           ( _2 )
# 534 "lib/BPFParser.ml"
     : (int))

let _menhir_action_25 =
  fun _2 _3 ->
    (
# 46 "lib/BPFParser.mly"
                                  ( _2,_3 )
# 542 "lib/BPFParser.ml"
     : (MiscParser.proc list * BPFBase.pseudo list list))

let _menhir_action_26 =
  fun ps ->
    (
# 54 "lib/BPFParser.mly"
  ( List.map (fun p -> p,None,MiscParser.Main) ps )
# 550 "lib/BPFParser.ml"
     : (MiscParser.proc list))

let _menhir_action_27 =
  fun _1 ->
    (
# 73 "lib/BPFParser.mly"
           ( A.Symbolic_reg _1 )
# 558 "lib/BPFParser.ml"
     : (A.reg_arg))

let _menhir_action_28 =
  fun _1 ->
    (
# 74 "lib/BPFParser.mly"
           ( _1 )
# 566 "lib/BPFParser.ml"
     : (A.reg_arg))

let _menhir_action_29 =
  fun () ->
    (
# 49 "lib/BPFParser.mly"
  ( () )
# 574 "lib/BPFParser.ml"
     : (unit))

let _menhir_action_30 =
  fun () ->
    (
# 50 "lib/BPFParser.mly"
       ( () )
# 582 "lib/BPFParser.ml"
     : (unit))

let _menhir_action_31 =
  fun x ->
    (
# 250 "<standard.mly>"
    ( [ x ] )
# 590 "lib/BPFParser.ml"
     : (int list))

let _menhir_action_32 =
  fun x xs ->
    (
# 253 "<standard.mly>"
    ( x :: xs )
# 598 "lib/BPFParser.ml"
     : (int list))

let _menhir_print_token : token -> string =
  fun _tok ->
    match _tok with
    | ALU_OP _ ->
        "ALU_OP"
    | AMOCMPXCHGT _ ->
        "AMOCMPXCHGT"
    | AMOF _ ->
        "AMOF"
    | AMOXCHGT _ ->
        "AMOXCHGT"
    | ARCH_REG _ ->
        "ARCH_REG"
    | COLON ->
        "COLON"
    | COMMA ->
        "COMMA"
    | COND _ ->
        "COND"
    | EOF ->
        "EOF"
    | EQUAL ->
        "EQUAL"
    | GOTO ->
        "GOTO"
    | IF ->
        "IF"
    | LOCK ->
        "LOCK"
    | LPAR ->
        "LPAR"
    | MINUS ->
        "MINUS"
    | NAME _ ->
        "NAME"
    | NUM _ ->
        "NUM"
    | PIPE ->
        "PIPE"
    | PLUS ->
        "PLUS"
    | PROC _ ->
        "PROC"
    | RPAR ->
        "RPAR"
    | SEMI ->
        "SEMI"
    | SIZE _ ->
        "SIZE"
    | STAR ->
        "STAR"
    | SYMB_REG _ ->
        "SYMB_REG"

let _menhir_fail : unit -> 'a =
  fun () ->
    Printf.eprintf "Internal failure -- please contact the parser generator's developers.\n%!";
    assert false

include struct
  
  [@@@ocaml.warning "-4-37"]
  
  let _menhir_run_100 : type  ttv_stack. (ttv_stack _menhir_cell0_semi_opt, _menhir_box_main) _menhir_cell1_proc_list -> _ -> _menhir_box_main =
    fun _menhir_stack _v ->
      let MenhirCell1_proc_list (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell0_semi_opt (_menhir_stack, _) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_25 _2 _3 in
      MenhirBox_main _v
  
  let rec _menhir_goto_iol_list : type  ttv_stack. ttv_stack -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _v _menhir_s ->
      match _menhir_s with
      | MenhirState103 ->
          _menhir_run_104 _menhir_stack _v
      | MenhirState008 ->
          _menhir_run_100 _menhir_stack _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_104 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_instr_option_list -> _ -> _menhir_box_main =
    fun _menhir_stack _v ->
      let MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_21 _1 _3 in
      _menhir_goto_iol_list _menhir_stack _v _menhir_s
  
  let rec _menhir_run_009 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_27 _1 in
      _menhir_goto_reg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_reg : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState095 ->
          _menhir_run_096 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState054 ->
          _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState090 ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState088 ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState085 ->
          _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState081 ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState077 ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState068 ->
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState065 ->
          _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState060 ->
          _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState106 ->
          _menhir_run_053 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState103 ->
          _menhir_run_053 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState008 ->
          _menhir_run_053 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState029 ->
          _menhir_run_053 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState044 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState042 ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState040 ->
          _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState036 ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState025 ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState015 ->
          _menhir_run_017 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_096 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_reg _menhir_cell0_ALU_OP -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell0_ALU_OP (_menhir_stack, _2) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_01 _1 _2 _3 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_instr : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _1 = _v in
      let _v = _menhir_action_17 _1 in
      _menhir_goto_instr_option _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_instr_option : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState008 ->
          _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState106 ->
          _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState103 ->
          _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState029 ->
          _menhir_run_098 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_105 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | PIPE ->
          let _menhir_stack = MenhirCell1_instr_option (_menhir_stack, _menhir_s, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v_0 ->
              _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState106
          | STAR ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState106
          | NAME _v_1 ->
              _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState106
          | LOCK ->
              _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState106
          | IF ->
              _menhir_run_042 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState106
          | GOTO ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState106
          | ARCH_REG _v_2 ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState106
          | PIPE | SEMI ->
              let _v_3 = _menhir_action_15 () in
              _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState106 _tok
          | _ ->
              _eRR ())
      | SEMI ->
          let _1 = _v in
          let _v = _menhir_action_18 _1 in
          _menhir_goto_instr_option_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_010 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_STAR (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SIZE _v ->
              let _menhir_stack = MenhirCell0_SIZE (_menhir_stack, _v) in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | STAR ->
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  (match (_tok : MenhirBasics.token) with
                  | RPAR ->
                      let _tok = _menhir_lexer _menhir_lexbuf in
                      (match (_tok : MenhirBasics.token) with
                      | LPAR ->
                          let _menhir_s = MenhirState015 in
                          let _tok = _menhir_lexer _menhir_lexbuf in
                          (match (_tok : MenhirBasics.token) with
                          | SYMB_REG _v ->
                              _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                          | ARCH_REG _v ->
                              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                          | _ ->
                              _eRR ())
                      | _ ->
                          _eRR ())
                  | _ ->
                      _eRR ())
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_016 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_28 _1 in
      _menhir_goto_reg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_028 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_NAME (_menhir_stack, _menhir_s, _v) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | COLON ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v_0 ->
              _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState029
          | STAR ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState029
          | NAME _v_1 ->
              _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState029
          | LOCK ->
              _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState029
          | IF ->
              _menhir_run_042 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState029
          | GOTO ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState029
          | ARCH_REG _v_2 ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState029
          | PIPE | SEMI ->
              let _v_3 = _menhir_action_15 () in
              _menhir_run_098 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 _tok
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_030 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_LOCK (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | STAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | LPAR ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | SIZE _v ->
                  let _menhir_stack = MenhirCell0_SIZE (_menhir_stack, _v) in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  (match (_tok : MenhirBasics.token) with
                  | STAR ->
                      let _tok = _menhir_lexer _menhir_lexbuf in
                      (match (_tok : MenhirBasics.token) with
                      | RPAR ->
                          let _tok = _menhir_lexer _menhir_lexbuf in
                          (match (_tok : MenhirBasics.token) with
                          | LPAR ->
                              let _menhir_s = MenhirState036 in
                              let _tok = _menhir_lexer _menhir_lexbuf in
                              (match (_tok : MenhirBasics.token) with
                              | SYMB_REG _v ->
                                  _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                              | ARCH_REG _v ->
                                  _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                              | _ ->
                                  _eRR ())
                          | _ ->
                              _eRR ())
                      | _ ->
                          _eRR ())
                  | _ ->
                      _eRR ())
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_042 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_IF (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState042 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v ->
          _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ARCH_REG _v ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_051 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | NAME _v ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _2 = _v in
          let _v = _menhir_action_12 _2 in
          _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_098 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_NAME -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_NAME (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_16 _1 _3 in
      _menhir_goto_instr_option _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_instr_option_list : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState106 ->
          _menhir_run_107 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState103 ->
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | MenhirState008 ->
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_107 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_instr_option -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_instr_option (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_19 _1 _3 in
      _menhir_goto_instr_option_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_run_102 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v_0 ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState103
      | STAR ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState103
      | NAME _v_1 ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState103
      | LOCK ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState103
      | IF ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_042 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState103
      | GOTO ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState103
      | ARCH_REG _v_2 ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState103
      | PIPE | SEMI ->
          let _menhir_stack = MenhirCell1_instr_option_list (_menhir_stack, _menhir_s, _v) in
          let _v_3 = _menhir_action_15 () in
          _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState103 _tok
      | EOF ->
          let _1 = _v in
          let _v = _menhir_action_20 _1 in
          _menhir_goto_iol_list _menhir_stack _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_093 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_06 _1 _3 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_091 : type  ttv_stack. (((((ttv_stack, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_AMOCMPXCHGT, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_k, _menhir_box_main) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_reg (_menhir_stack, _, _) = _menhir_stack in
          let MenhirCell1_k (_menhir_stack, _, _6) = _menhir_stack in
          let MenhirCell1_reg (_menhir_stack, _, _5) = _menhir_stack in
          let MenhirCell1_AMOCMPXCHGT (_menhir_stack, _, _3) = _menhir_stack in
          let MenhirCell1_reg (_menhir_stack, _menhir_s, _) = _menhir_stack in
          let _10 = _v in
          let _v = _menhir_action_10 _10 _3 _5 _6 in
          _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_089 : type  ttv_stack. (((((ttv_stack, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_AMOCMPXCHGT, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_k as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState090 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_086 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_AMOCMPXCHGT as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | PLUS ->
          _menhir_run_018 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState086
      | NUM _v_0 ->
          _menhir_run_020 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState086
      | MINUS ->
          _menhir_run_021 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState086
      | _ ->
          _eRR ()
  
  and _menhir_run_018 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | NUM _v ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _2 = _v in
          let _v = _menhir_action_24 _2 in
          _menhir_goto_k _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_k : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState095 ->
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState054 ->
          _menhir_run_094 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState086 ->
          _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState078 ->
          _menhir_run_079 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState066 ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState061 ->
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState044 ->
          _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState037 ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState025 ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState017 ->
          _menhir_run_023 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_097 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_reg _menhir_cell0_ALU_OP -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell0_ALU_OP (_menhir_stack, _2) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_02 _1 _2 _3 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_094 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_reg (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_07 _1 _3 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_087 : type  ttv_stack. ((((ttv_stack, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_AMOCMPXCHGT, _menhir_box_main) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_k (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState088 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_079 : type  ttv_stack. ((((ttv_stack, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_AMOF _menhir_cell0_SIZE, _menhir_box_main) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_k (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | COMMA ->
              let _menhir_s = MenhirState081 in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | SYMB_REG _v ->
                  _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | ARCH_REG _v ->
                  _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_067 : type  ttv_stack. ((((ttv_stack, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_AMOXCHGT, _menhir_box_main) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_k (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState068 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ARCH_REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_062 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_STAR _menhir_cell0_SIZE, _menhir_box_main) _menhir_cell1_reg -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_reg (_menhir_stack, _, _9) = _menhir_stack in
          let MenhirCell0_SIZE (_menhir_stack, _5) = _menhir_stack in
          let MenhirCell1_STAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_reg (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          let _10 = _v in
          let _v = _menhir_action_03 _1 _10 _5 _9 in
          _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_048 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_IF, _menhir_box_main) _menhir_cell1_reg _menhir_cell0_COND -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | GOTO ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NAME _v_0 ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let MenhirCell0_COND (_menhir_stack, _3) = _menhir_stack in
              let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
              let MenhirCell1_IF (_menhir_stack, _menhir_s) = _menhir_stack in
              let (_6, _4) = (_v_0, _v) in
              let _v = _menhir_action_14 _2 _3 _4 _6 in
              _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_038 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_LOCK _menhir_cell0_SIZE, _menhir_box_main) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_k (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | ALU_OP _v ->
              let _menhir_stack = MenhirCell0_ALU_OP (_menhir_stack, _v) in
              let _menhir_s = MenhirState040 in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | SYMB_REG _v ->
                  _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | ARCH_REG _v ->
                  _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_027 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_STAR _menhir_cell0_SIZE, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_k -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_k (_menhir_stack, _, _8) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _7) = _menhir_stack in
      let MenhirCell0_SIZE (_menhir_stack, _3) = _menhir_stack in
      let MenhirCell1_STAR (_menhir_stack, _menhir_s) = _menhir_stack in
      let _11 = _v in
      let _v = _menhir_action_05 _11 _3 _7 _8 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_023 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_STAR _menhir_cell0_SIZE, _menhir_box_main) _menhir_cell1_reg as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_k (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | EQUAL ->
              let _menhir_s = MenhirState025 in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | SYMB_REG _v ->
                  _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | PLUS ->
                  _menhir_run_018 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | NUM _v ->
                  _menhir_run_020 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | MINUS ->
                  _menhir_run_021 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | ARCH_REG _v ->
                  _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_020 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_22 _1 in
      _menhir_goto_k _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_021 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | NUM _v ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _2 = _v in
          let _v = _menhir_action_23 _2 in
          _menhir_goto_k _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_082 : type  ttv_stack. ((((ttv_stack, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_AMOF _menhir_cell0_SIZE, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_k -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_k (_menhir_stack, _, _11) = _menhir_stack in
          let MenhirCell1_reg (_menhir_stack, _, _10) = _menhir_stack in
          let MenhirCell0_SIZE (_menhir_stack, _6) = _menhir_stack in
          let MenhirCell1_AMOF (_menhir_stack, _, _3) = _menhir_stack in
          let MenhirCell1_reg (_menhir_stack, _menhir_s, _) = _menhir_stack in
          let _14 = _v in
          let _v = _menhir_action_08 _10 _11 _14 _3 _6 in
          _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_078 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_AMOF _menhir_cell0_SIZE as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | PLUS ->
          _menhir_run_018 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState078
      | NUM _v_0 ->
          _menhir_run_020 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState078
      | MINUS ->
          _menhir_run_021 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState078
      | _ ->
          _eRR ()
  
  and _menhir_run_069 : type  ttv_stack. ((((ttv_stack, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_AMOXCHGT, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_k -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_k (_menhir_stack, _, _6) = _menhir_stack in
          let MenhirCell1_reg (_menhir_stack, _, _5) = _menhir_stack in
          let MenhirCell1_AMOXCHGT (_menhir_stack, _, _3) = _menhir_stack in
          let MenhirCell1_reg (_menhir_stack, _menhir_s, _) = _menhir_stack in
          let _8 = _v in
          let _v = _menhir_action_09 _3 _5 _6 _8 in
          _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_066 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_AMOXCHGT as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | PLUS ->
          _menhir_run_018 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState066
      | NUM _v_0 ->
          _menhir_run_020 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState066
      | MINUS ->
          _menhir_run_021 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState066
      | _ ->
          _eRR ()
  
  and _menhir_run_061 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_STAR _menhir_cell0_SIZE as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | PLUS ->
          _menhir_run_018 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState061
      | NUM _v_0 ->
          _menhir_run_020 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState061
      | MINUS ->
          _menhir_run_021 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState061
      | _ ->
          _eRR ()
  
  and _menhir_run_053 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | EQUAL ->
          let _menhir_s = MenhirState054 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STAR ->
              let _menhir_stack = MenhirCell1_STAR (_menhir_stack, _menhir_s) in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | LPAR ->
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  (match (_tok : MenhirBasics.token) with
                  | SIZE _v ->
                      let _menhir_stack = MenhirCell0_SIZE (_menhir_stack, _v) in
                      let _tok = _menhir_lexer _menhir_lexbuf in
                      (match (_tok : MenhirBasics.token) with
                      | STAR ->
                          let _tok = _menhir_lexer _menhir_lexbuf in
                          (match (_tok : MenhirBasics.token) with
                          | RPAR ->
                              let _tok = _menhir_lexer _menhir_lexbuf in
                              (match (_tok : MenhirBasics.token) with
                              | LPAR ->
                                  let _menhir_s = MenhirState060 in
                                  let _tok = _menhir_lexer _menhir_lexbuf in
                                  (match (_tok : MenhirBasics.token) with
                                  | SYMB_REG _v ->
                                      _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                                  | ARCH_REG _v ->
                                      _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                                  | _ ->
                                      _eRR ())
                              | _ ->
                                  _eRR ())
                          | _ ->
                              _eRR ())
                      | _ ->
                          _eRR ())
                  | _ ->
                      _eRR ())
              | _ ->
                  _eRR ())
          | PLUS ->
              _menhir_run_018 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NUM _v ->
              _menhir_run_020 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | MINUS ->
              _menhir_run_021 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ARCH_REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | AMOXCHGT _v ->
              let _menhir_stack = MenhirCell1_AMOXCHGT (_menhir_stack, _menhir_s, _v) in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | LPAR ->
                  let _menhir_s = MenhirState065 in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  (match (_tok : MenhirBasics.token) with
                  | SYMB_REG _v ->
                      _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                  | ARCH_REG _v ->
                      _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                  | _ ->
                      _eRR ())
              | _ ->
                  _eRR ())
          | AMOF _v ->
              let _menhir_stack = MenhirCell1_AMOF (_menhir_stack, _menhir_s, _v) in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | LPAR ->
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  (match (_tok : MenhirBasics.token) with
                  | LPAR ->
                      let _tok = _menhir_lexer _menhir_lexbuf in
                      (match (_tok : MenhirBasics.token) with
                      | SIZE _v ->
                          let _menhir_stack = MenhirCell0_SIZE (_menhir_stack, _v) in
                          let _tok = _menhir_lexer _menhir_lexbuf in
                          (match (_tok : MenhirBasics.token) with
                          | STAR ->
                              let _tok = _menhir_lexer _menhir_lexbuf in
                              (match (_tok : MenhirBasics.token) with
                              | RPAR ->
                                  let _tok = _menhir_lexer _menhir_lexbuf in
                                  (match (_tok : MenhirBasics.token) with
                                  | LPAR ->
                                      let _menhir_s = MenhirState077 in
                                      let _tok = _menhir_lexer _menhir_lexbuf in
                                      (match (_tok : MenhirBasics.token) with
                                      | SYMB_REG _v ->
                                          _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                                      | ARCH_REG _v ->
                                          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                                      | _ ->
                                          _eRR ())
                                  | _ ->
                                      _eRR ())
                              | _ ->
                                  _eRR ())
                          | _ ->
                              _eRR ())
                      | _ ->
                          _eRR ())
                  | _ ->
                      _eRR ())
              | _ ->
                  _eRR ())
          | AMOCMPXCHGT _v ->
              let _menhir_stack = MenhirCell1_AMOCMPXCHGT (_menhir_stack, _menhir_s, _v) in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | LPAR ->
                  let _menhir_s = MenhirState085 in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  (match (_tok : MenhirBasics.token) with
                  | SYMB_REG _v ->
                      _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                  | ARCH_REG _v ->
                      _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                  | _ ->
                      _eRR ())
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | ALU_OP _v_16 ->
          let _menhir_stack = MenhirCell0_ALU_OP (_menhir_stack, _v_16) in
          let _menhir_s = MenhirState095 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | PLUS ->
              _menhir_run_018 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NUM _v ->
              _menhir_run_020 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | MINUS ->
              _menhir_run_021 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ARCH_REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_045 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_IF, _menhir_box_main) _menhir_cell1_reg _menhir_cell0_COND -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | GOTO ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NAME _v_0 ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let MenhirCell0_COND (_menhir_stack, _3) = _menhir_stack in
              let MenhirCell1_reg (_menhir_stack, _, _2) = _menhir_stack in
              let MenhirCell1_IF (_menhir_stack, _menhir_s) = _menhir_stack in
              let (_6, _4) = (_v_0, _v) in
              let _v = _menhir_action_13 _2 _3 _4 _6 in
              _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_043 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_IF as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COND _v_0 ->
          let _menhir_stack = MenhirCell0_COND (_menhir_stack, _v_0) in
          let _menhir_s = MenhirState044 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SYMB_REG _v ->
              _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | PLUS ->
              _menhir_run_018 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NUM _v ->
              _menhir_run_020 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | MINUS ->
              _menhir_run_021 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ARCH_REG _v ->
              _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_041 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_LOCK _menhir_cell0_SIZE, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_k _menhir_cell0_ALU_OP -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell0_ALU_OP (_menhir_stack, _11) = _menhir_stack in
      let MenhirCell1_k (_menhir_stack, _, _9) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _8) = _menhir_stack in
      let MenhirCell0_SIZE (_menhir_stack, _4) = _menhir_stack in
      let MenhirCell1_LOCK (_menhir_stack, _menhir_s) = _menhir_stack in
      let _12 = _v in
      let _v = _menhir_action_11 _11 _12 _4 _8 _9 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_037 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_LOCK _menhir_cell0_SIZE as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | PLUS ->
          _menhir_run_018 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState037
      | NUM _v_0 ->
          _menhir_run_020 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState037
      | MINUS ->
          _menhir_run_021 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState037
      | _ ->
          _eRR ()
  
  and _menhir_run_026 : type  ttv_stack. (((ttv_stack, _menhir_box_main) _menhir_cell1_STAR _menhir_cell0_SIZE, _menhir_box_main) _menhir_cell1_reg, _menhir_box_main) _menhir_cell1_k -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_k (_menhir_stack, _, _8) = _menhir_stack in
      let MenhirCell1_reg (_menhir_stack, _, _7) = _menhir_stack in
      let MenhirCell0_SIZE (_menhir_stack, _3) = _menhir_stack in
      let MenhirCell1_STAR (_menhir_stack, _menhir_s) = _menhir_stack in
      let _11 = _v in
      let _v = _menhir_action_04 _11 _3 _7 _8 in
      _menhir_goto_instr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_017 : type  ttv_stack. ((ttv_stack, _menhir_box_main) _menhir_cell1_STAR _menhir_cell0_SIZE as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_reg (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | PLUS ->
          _menhir_run_018 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState017
      | NUM _v_0 ->
          _menhir_run_020 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState017
      | MINUS ->
          _menhir_run_021 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState017
      | _ ->
          _eRR ()
  
  let _menhir_run_006 : type  ttv_stack. (ttv_stack _menhir_cell0_semi_opt as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let ps = _v in
      let _v = _menhir_action_26 ps in
      let _menhir_stack = MenhirCell1_proc_list (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | SYMB_REG _v_0 ->
          _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState008
      | STAR ->
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState008
      | NAME _v_1 ->
          _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState008
      | LOCK ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState008
      | IF ->
          _menhir_run_042 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState008
      | GOTO ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState008
      | ARCH_REG _v_2 ->
          _menhir_run_016 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState008
      | PIPE | SEMI ->
          let _v_3 = _menhir_action_15 () in
          _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState008 _tok
      | _ ->
          _eRR ()
  
  let rec _menhir_goto_separated_nonempty_list_PIPE_PROC_ : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState002 ->
          _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | MenhirState004 ->
          _menhir_run_005 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_005 : type  ttv_stack. (ttv_stack, _menhir_box_main) _menhir_cell1_PROC -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_PROC (_menhir_stack, _menhir_s, x) = _menhir_stack in
      let xs = _v in
      let _v = _menhir_action_32 x xs in
      _menhir_goto_separated_nonempty_list_PIPE_PROC_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  let rec _menhir_run_003 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_main) _menhir_state -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | PIPE ->
          let _menhir_stack = MenhirCell1_PROC (_menhir_stack, _menhir_s, _v) in
          let _menhir_s = MenhirState004 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | PROC _v ->
              _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | SEMI ->
          let x = _v in
          let _v = _menhir_action_31 x in
          _menhir_goto_separated_nonempty_list_PIPE_PROC_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  let _menhir_goto_semi_opt : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let _menhir_stack = MenhirCell0_semi_opt (_menhir_stack, _v) in
      match (_tok : MenhirBasics.token) with
      | PROC _v_0 ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState002
      | _ ->
          _eRR ()
  
  let _menhir_run_000 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SEMI ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _v = _menhir_action_30 () in
          _menhir_goto_semi_opt _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | PROC _ ->
          let _v = _menhir_action_29 () in
          _menhir_goto_semi_opt _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _eRR ()
  
end

let main =
  fun _menhir_lexer _menhir_lexbuf ->
    let _menhir_stack = () in
    let MenhirBox_main v = _menhir_run_000 _menhir_stack _menhir_lexbuf _menhir_lexer in
    v
